/*******************************************************************************
 * Copyright (c) 2000, 2020 IBM Corp. and others
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution and
 * is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] http://openjdk.java.net/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0 WITH Classpath-exception-2.0 OR LicenseRef-GPL-2.0 WITH Assembly-exception
 *******************************************************************************/

/*
 * This table is #included in a static table.
 * Only Function Pointers are allowed.
 */

#define _dfconstEvaluator TR::TreeEvaluator::fconstEvaluator
#define _ddconstEvaluator TR::TreeEvaluator::dconstEvaluator
#define _deconstEvaluator TR::TreeEvaluator::deconstEvaluator
#define _dfloadEvaluator TR::TreeEvaluator::floadEvaluator
#define _ddloadEvaluator TR::TreeEvaluator::dloadEvaluator
#define _deloadEvaluator TR::TreeEvaluator::deloadEvaluator
#define _dfloadiEvaluator TR::TreeEvaluator::floadEvaluator
#define _ddloadiEvaluator TR::TreeEvaluator::dloadEvaluator
#define _deloadiEvaluator TR::TreeEvaluator::deloadEvaluator
#define _dfstoreEvaluator TR::TreeEvaluator::fstoreEvaluator
#define _ddstoreEvaluator TR::TreeEvaluator::dstoreEvaluator
#define _destoreEvaluator TR::TreeEvaluator::destoreEvaluator
#define _dfstoreiEvaluator TR::TreeEvaluator::fstoreEvaluator
#define _ddstoreiEvaluator TR::TreeEvaluator::dstoreEvaluator
#define _destoreiEvaluator TR::TreeEvaluator::destoreEvaluator
#define _dfreturnEvaluator TR::TreeEvaluator::returnEvaluator
#define _ddreturnEvaluator TR::TreeEvaluator::returnEvaluator
#define _dereturnEvaluator TR::TreeEvaluator::returnEvaluator
#define _dfcallEvaluator TR::TreeEvaluator::directCallEvaluator
#define _ddcallEvaluator TR::TreeEvaluator::directCallEvaluator
#define _decallEvaluator TR::TreeEvaluator::directCallEvaluator
#define _dfcalliEvaluator TR::TreeEvaluator::indirectCallEvaluator
#define _ddcalliEvaluator TR::TreeEvaluator::indirectCallEvaluator
#define _decalliEvaluator TR::TreeEvaluator::indirectCallEvaluator
#define _dfaddEvaluator TR::TreeEvaluator::dfaddEvaluator
#define _ddaddEvaluator TR::TreeEvaluator::ddaddEvaluator
#define _deaddEvaluator TR::TreeEvaluator::deaddEvaluator
#define _dfsubEvaluator TR::TreeEvaluator::dfsubEvaluator
#define _ddsubEvaluator TR::TreeEvaluator::ddsubEvaluator
#define _desubEvaluator TR::TreeEvaluator::desubEvaluator
#define _dfmulEvaluator TR::TreeEvaluator::dfmulEvaluator
#define _ddmulEvaluator TR::TreeEvaluator::ddmulEvaluator
#define _demulEvaluator TR::TreeEvaluator::demulEvaluator
#define _dfdivEvaluator TR::TreeEvaluator::dfdivEvaluator
#define _dddivEvaluator TR::TreeEvaluator::dfdivEvaluator
#define _dedivEvaluator TR::TreeEvaluator::dfdivEvaluator
#define _dfremEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ddremEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _deremEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfnegEvaluator TR::TreeEvaluator::ddnegEvaluator
#define _ddnegEvaluator TR::TreeEvaluator::ddnegEvaluator
#define _denegEvaluator TR::TreeEvaluator::ddnegEvaluator
#define _dfabsEvaluator TR::TreeEvaluator::iabsEvaluator
#define _ddabsEvaluator TR::TreeEvaluator::iabsEvaluator
#define _deabsEvaluator TR::TreeEvaluator::iabsEvaluator
#define _dfshlEvaluator TR::TreeEvaluator::ddshlEvaluator
#define _dfshrEvaluator TR::TreeEvaluator::ddshrEvaluator
#define _ddshlEvaluator TR::TreeEvaluator::ddshlEvaluator
#define _ddshrEvaluator TR::TreeEvaluator::ddshrEvaluator
#define _deshlEvaluator TR::TreeEvaluator::ddshlEvaluator
#define _deshrEvaluator TR::TreeEvaluator::ddshrEvaluator
#define _dfshrRoundedEvaluator TR::TreeEvaluator::ddshrRoundedEvaluator
#define _ddshrRoundedEvaluator TR::TreeEvaluator::ddshrRoundedEvaluator
#define _deshrRoundedEvaluator TR::TreeEvaluator::ddshrRoundedEvaluator
#define _dfSetNegativeEvaluator TR::TreeEvaluator::ddSetNegativeEvaluator
#define _ddSetNegativeEvaluator TR::TreeEvaluator::ddSetNegativeEvaluator
#define _deSetNegativeEvaluator TR::TreeEvaluator::ddSetNegativeEvaluator
#define _dfModifyPrecisionEvaluator TR::TreeEvaluator::ddModifyPrecisionEvaluator
#define _ddModifyPrecisionEvaluator TR::TreeEvaluator::ddModifyPrecisionEvaluator
#define _deModifyPrecisionEvaluator TR::TreeEvaluator::ddModifyPrecisionEvaluator
#define _i2dfEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _iu2dfEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _l2dfEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _lu2dfEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _f2dfEvaluator TR::TreeEvaluator::f2dfEvaluator
#define _d2dfEvaluator TR::TreeEvaluator::f2dfEvaluator
#define _dd2dfEvaluator TR::TreeEvaluator::dd2dfEvaluator
#define _de2dfEvaluator TR::TreeEvaluator::de2ddEvaluator
#define _b2dfEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _bu2dfEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _s2dfEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _su2dfEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _df2iEvaluator TR::TreeEvaluator::dd2iEvaluator
#define _df2iuEvaluator TR::TreeEvaluator::dd2iEvaluator
#define _df2lEvaluator TR::TreeEvaluator::dd2lEvaluator
#define _df2luEvaluator TR::TreeEvaluator::dd2lEvaluator
#define _df2fEvaluator TR::TreeEvaluator::df2fEvaluator
#define _df2dEvaluator TR::TreeEvaluator::df2fEvaluator
#define _df2ddEvaluator TR::TreeEvaluator::df2ddEvaluator
#define _df2deEvaluator TR::TreeEvaluator::df2deEvaluator
#define _df2bEvaluator TR::TreeEvaluator::dd2iEvaluator
#define _df2buEvaluator TR::TreeEvaluator::dd2iEvaluator
#define _df2sEvaluator TR::TreeEvaluator::dd2iEvaluator
#define _df2cEvaluator TR::TreeEvaluator::dd2iEvaluator
#define _i2ddEvaluator TR::TreeEvaluator::i2ddEvaluator
#define _iu2ddEvaluator TR::TreeEvaluator::i2ddEvaluator
#define _l2ddEvaluator TR::TreeEvaluator::l2ddEvaluator
#define _lu2ddEvaluator TR::TreeEvaluator::lu2ddEvaluator
#define _f2ddEvaluator TR::TreeEvaluator::f2dfEvaluator
#define _d2ddEvaluator TR::TreeEvaluator::f2dfEvaluator
#define _de2ddEvaluator TR::TreeEvaluator::de2ddEvaluator
#define _b2ddEvaluator TR::TreeEvaluator::i2ddEvaluator
#define _bu2ddEvaluator TR::TreeEvaluator::i2ddEvaluator
#define _s2ddEvaluator TR::TreeEvaluator::i2ddEvaluator
#define _su2ddEvaluator TR::TreeEvaluator::i2ddEvaluator
#define _dd2iEvaluator TR::TreeEvaluator::dd2iEvaluator
#define _dd2iuEvaluator TR::TreeEvaluator::dd2iEvaluator
#define _dd2lEvaluator TR::TreeEvaluator::dd2lEvaluator
#define _dd2luEvaluator TR::TreeEvaluator::dd2luEvaluator
#define _dd2fEvaluator TR::TreeEvaluator::df2fEvaluator
#define _dd2dEvaluator TR::TreeEvaluator::df2fEvaluator
#define _dd2deEvaluator TR::TreeEvaluator::dd2deEvaluator
#define _dd2bEvaluator TR::TreeEvaluator::dd2iEvaluator
#define _dd2buEvaluator TR::TreeEvaluator::dd2iEvaluator
#define _dd2sEvaluator TR::TreeEvaluator::dd2iEvaluator
#define _dd2cEvaluator TR::TreeEvaluator::dd2iEvaluator
#define _i2deEvaluator TR::TreeEvaluator::i2ddEvaluator
#define _iu2deEvaluator TR::TreeEvaluator::i2ddEvaluator
#define _l2deEvaluator TR::TreeEvaluator::l2ddEvaluator
#define _lu2deEvaluator TR::TreeEvaluator::lu2ddEvaluator
#define _f2deEvaluator TR::TreeEvaluator::f2dfEvaluator
#define _d2deEvaluator TR::TreeEvaluator::f2dfEvaluator
#define _b2deEvaluator TR::TreeEvaluator::i2ddEvaluator
#define _bu2deEvaluator TR::TreeEvaluator::i2ddEvaluator
#define _s2deEvaluator TR::TreeEvaluator::i2ddEvaluator
#define _su2deEvaluator TR::TreeEvaluator::i2ddEvaluator
#define _de2iEvaluator TR::TreeEvaluator::dd2iEvaluator
#define _de2iuEvaluator TR::TreeEvaluator::dd2iEvaluator
#define _de2lEvaluator TR::TreeEvaluator::dd2lEvaluator
#define _de2luEvaluator TR::TreeEvaluator::dd2luEvaluator
#define _de2fEvaluator TR::TreeEvaluator::df2fEvaluator
#define _de2dEvaluator TR::TreeEvaluator::df2fEvaluator
#define _de2bEvaluator TR::TreeEvaluator::dd2iEvaluator
#define _de2buEvaluator TR::TreeEvaluator::dd2iEvaluator
#define _de2sEvaluator TR::TreeEvaluator::dd2iEvaluator
#define _de2cEvaluator TR::TreeEvaluator::dd2iEvaluator
#define _ifdfcmpeqEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ifdfcmpneEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ifdfcmpltEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ifdfcmpgeEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ifdfcmpgtEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ifdfcmpleEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ifdfcmpequEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ifdfcmpneuEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ifdfcmpltuEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ifdfcmpgeuEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ifdfcmpgtuEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ifdfcmpleuEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfcmpeqEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfcmpneEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfcmpltEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfcmpgeEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfcmpgtEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfcmpleEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfcmpequEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfcmpneuEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfcmpltuEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfcmpgeuEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfcmpgtuEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfcmpleuEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ifddcmpeqEvaluator TR::TreeEvaluator::ifddcmpeqEvaluator
#define _ifddcmpneEvaluator TR::TreeEvaluator::ifddcmpneEvaluator
#define _ifddcmpltEvaluator TR::TreeEvaluator::ifddcmpltEvaluator
#define _ifddcmpgeEvaluator TR::TreeEvaluator::ifddcmpgeEvaluator
#define _ifddcmpgtEvaluator TR::TreeEvaluator::ifddcmpgtEvaluator
#define _ifddcmpleEvaluator TR::TreeEvaluator::ifddcmpleEvaluator
#define _ifddcmpequEvaluator TR::TreeEvaluator::ifddcmpequEvaluator
#define _ifddcmpneuEvaluator TR::TreeEvaluator::ifddcmpneuEvaluator
#define _ifddcmpltuEvaluator TR::TreeEvaluator::ifddcmpltuEvaluator
#define _ifddcmpgeuEvaluator TR::TreeEvaluator::ifddcmpgeuEvaluator
#define _ifddcmpgtuEvaluator TR::TreeEvaluator::ifddcmpgtuEvaluator
#define _ifddcmpleuEvaluator TR::TreeEvaluator::ifddcmpleuEvaluator
#define _ddcmpeqEvaluator TR::TreeEvaluator::ddcmpeqEvaluator
#define _ddcmpneEvaluator TR::TreeEvaluator::ddcmpneEvaluator
#define _ddcmpltEvaluator TR::TreeEvaluator::ddcmpltEvaluator
#define _ddcmpgeEvaluator TR::TreeEvaluator::ddcmpgeEvaluator
#define _ddcmpgtEvaluator TR::TreeEvaluator::ddcmpgtEvaluator
#define _ddcmpleEvaluator TR::TreeEvaluator::ddcmpleEvaluator
#define _ddcmpequEvaluator TR::TreeEvaluator::ddcmpequEvaluator
#define _ddcmpneuEvaluator TR::TreeEvaluator::ddcmpneuEvaluator
#define _ddcmpltuEvaluator TR::TreeEvaluator::ddcmpltuEvaluator
#define _ddcmpgeuEvaluator TR::TreeEvaluator::ddcmpgeuEvaluator
#define _ddcmpgtuEvaluator TR::TreeEvaluator::ddcmpgtuEvaluator
#define _ddcmpleuEvaluator TR::TreeEvaluator::ddcmpleuEvaluator
#define _ifdecmpeqEvaluator TR::TreeEvaluator::ifddcmpeqEvaluator
#define _ifdecmpneEvaluator TR::TreeEvaluator::ifddcmpneEvaluator
#define _ifdecmpltEvaluator TR::TreeEvaluator::ifddcmpltEvaluator
#define _ifdecmpgeEvaluator TR::TreeEvaluator::ifddcmpgeEvaluator
#define _ifdecmpgtEvaluator TR::TreeEvaluator::ifddcmpgtEvaluator
#define _ifdecmpleEvaluator TR::TreeEvaluator::ifddcmpleEvaluator
#define _ifdecmpequEvaluator TR::TreeEvaluator::ifddcmpequEvaluator
#define _ifdecmpneuEvaluator TR::TreeEvaluator::ifddcmpneuEvaluator
#define _ifdecmpltuEvaluator TR::TreeEvaluator::ifddcmpltuEvaluator
#define _ifdecmpgeuEvaluator TR::TreeEvaluator::ifddcmpgeuEvaluator
#define _ifdecmpgtuEvaluator TR::TreeEvaluator::ifddcmpgtuEvaluator
#define _ifdecmpleuEvaluator TR::TreeEvaluator::ifddcmpleuEvaluator
#define _decmpeqEvaluator TR::TreeEvaluator::ddcmpeqEvaluator
#define _decmpneEvaluator TR::TreeEvaluator::ddcmpneEvaluator
#define _decmpltEvaluator TR::TreeEvaluator::ddcmpltEvaluator
#define _decmpgeEvaluator TR::TreeEvaluator::ddcmpgeEvaluator
#define _decmpgtEvaluator TR::TreeEvaluator::ddcmpgtEvaluator
#define _decmpleEvaluator TR::TreeEvaluator::ddcmpleEvaluator
#define _decmpequEvaluator TR::TreeEvaluator::ddcmpequEvaluator
#define _decmpneuEvaluator TR::TreeEvaluator::ddcmpneuEvaluator
#define _decmpltuEvaluator TR::TreeEvaluator::ddcmpltuEvaluator
#define _decmpgeuEvaluator TR::TreeEvaluator::ddcmpgeuEvaluator
#define _decmpgtuEvaluator TR::TreeEvaluator::ddcmpgtuEvaluator
#define _decmpleuEvaluator TR::TreeEvaluator::ddcmpleuEvaluator
#define _dfRegLoadEvaluator TR::TreeEvaluator::fRegLoadEvaluator
#define _ddRegLoadEvaluator TR::TreeEvaluator::dRegLoadEvaluator
#define _deRegLoadEvaluator TR::TreeEvaluator::deRegLoadEvaluator
#define _dfRegStoreEvaluator TR::TreeEvaluator::fRegStoreEvaluator
#define _ddRegStoreEvaluator TR::TreeEvaluator::dRegStoreEvaluator
#define _deRegStoreEvaluator TR::TreeEvaluator::deRegStoreEvaluator
#define _dfselectEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ddselectEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _deselectEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfexpEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ddexpEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _deexpEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfnintEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ddnintEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _denintEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfsqrtEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ddsqrtEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _desqrtEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfcosEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ddcosEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _decosEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfsinEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ddsinEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _desinEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dftanEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ddtanEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _detanEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfcoshEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ddcoshEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _decoshEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfsinhEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ddsinhEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _desinhEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dftanhEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ddtanhEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _detanhEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfacosEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ddacosEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _deacosEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfasinEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ddasinEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _deasinEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfatanEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ddatanEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _deatanEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfatan2Evaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ddatan2Evaluator TR::TreeEvaluator::unImpOpEvaluator
#define _deatan2Evaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dflogEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ddlogEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _delogEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dffloorEvaluator TR::TreeEvaluator::dffloorEvaluator
#define _ddfloorEvaluator TR::TreeEvaluator::ddfloorEvaluator
#define _defloorEvaluator TR::TreeEvaluator::defloorEvaluator
#define _dfceilEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ddceilEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _deceilEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfmaxEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ddmaxEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _demaxEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfminEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ddminEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _deminEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfInsExpEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ddInsExpEvaluator TR::TreeEvaluator::ddInsExpEvaluator
#define _deInsExpEvaluator TR::TreeEvaluator::ddInsExpEvaluator
#define _ddcleanEvaluator TR::TreeEvaluator::ddcleanEvaluator
#define _decleanEvaluator TR::TreeEvaluator::decleanEvaluator
#define _zdloadEvaluator TR::TreeEvaluator::pdloadEvaluator
#define _zdloadiEvaluator TR::TreeEvaluator::pdloadEvaluator
#define _zdstoreEvaluator TR::TreeEvaluator::pdstoreEvaluator
#define _zdstoreiEvaluator TR::TreeEvaluator::pdstoreEvaluator
#define _pd2zdEvaluator TR::TreeEvaluator::pd2zdEvaluator
#define _zd2pdEvaluator TR::TreeEvaluator::zd2pdEvaluator
#define _zdsleLoadEvaluator TR::TreeEvaluator::pdloadEvaluator
#define _zdslsLoadEvaluator TR::TreeEvaluator::pdloadEvaluator
#define _zdstsLoadEvaluator TR::TreeEvaluator::pdloadEvaluator
#define _zdsleLoadiEvaluator TR::TreeEvaluator::pdloadEvaluator
#define _zdslsLoadiEvaluator TR::TreeEvaluator::pdloadEvaluator
#define _zdstsLoadiEvaluator TR::TreeEvaluator::pdloadEvaluator
#define _zdsleStoreEvaluator TR::TreeEvaluator::pdstoreEvaluator
#define _zdslsStoreEvaluator TR::TreeEvaluator::pdstoreEvaluator
#define _zdstsStoreEvaluator TR::TreeEvaluator::pdstoreEvaluator
#define _zdsleStoreiEvaluator TR::TreeEvaluator::pdstoreEvaluator
#define _zdslsStoreiEvaluator TR::TreeEvaluator::pdstoreEvaluator
#define _zdstsStoreiEvaluator TR::TreeEvaluator::pdstoreEvaluator
#define _zd2zdsleEvaluator TR::TreeEvaluator::zdsle2zdEvaluator
#define _zd2zdslsEvaluator TR::TreeEvaluator::zd2zdslsEvaluator
#define _zd2zdstsEvaluator TR::TreeEvaluator::zd2zdslsEvaluator
#define _zdsle2pdEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _zdsls2pdEvaluator TR::TreeEvaluator::zdsls2pdEvaluator
#define _zdsts2pdEvaluator TR::TreeEvaluator::zdsls2pdEvaluator
#define _zdsle2zdEvaluator TR::TreeEvaluator::zdsle2zdEvaluator
#define _zdsls2zdEvaluator TR::TreeEvaluator::zdsls2zdEvaluator
#define _zdsts2zdEvaluator TR::TreeEvaluator::zdsls2zdEvaluator
#define _pd2zdslsEvaluator TR::TreeEvaluator::pd2zdslsEvaluator
#define _pd2zdslsSetSignEvaluator TR::TreeEvaluator::pd2zdslsEvaluator
#define _pd2zdstsEvaluator TR::TreeEvaluator::pd2zdslsEvaluator
#define _pd2zdstsSetSignEvaluator TR::TreeEvaluator::pd2zdslsEvaluator
#define _zd2dfEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _df2zdEvaluator TR::TreeEvaluator::df2zdEvaluator
#define _zd2ddEvaluator TR::TreeEvaluator::zd2ddEvaluator
#define _dd2zdEvaluator TR::TreeEvaluator::df2zdEvaluator
#define _zd2deEvaluator TR::TreeEvaluator::zd2ddEvaluator
#define _de2zdEvaluator TR::TreeEvaluator::df2zdEvaluator
#define _zd2dfAbsEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _zd2ddAbsEvaluator TR::TreeEvaluator::zd2ddEvaluator
#define _zd2deAbsEvaluator TR::TreeEvaluator::zd2ddEvaluator
#define _df2zdSetSignEvaluator TR::TreeEvaluator::df2zdEvaluator
#define _dd2zdSetSignEvaluator TR::TreeEvaluator::df2zdEvaluator
#define _de2zdSetSignEvaluator TR::TreeEvaluator::df2zdEvaluator
#define _df2zdCleanEvaluator TR::TreeEvaluator::df2zdEvaluator
#define _dd2zdCleanEvaluator TR::TreeEvaluator::df2zdEvaluator
#define _de2zdCleanEvaluator TR::TreeEvaluator::df2zdEvaluator
#define _udLoadEvaluator TR::TreeEvaluator::pdloadEvaluator
#define _udslLoadEvaluator TR::TreeEvaluator::pdloadEvaluator
#define _udstLoadEvaluator TR::TreeEvaluator::pdloadEvaluator
#define _udLoadiEvaluator TR::TreeEvaluator::pdloadEvaluator
#define _udslLoadiEvaluator TR::TreeEvaluator::pdloadEvaluator
#define _udstLoadiEvaluator TR::TreeEvaluator::pdloadEvaluator
#define _udStoreEvaluator TR::TreeEvaluator::pdstoreEvaluator
#define _udslStoreEvaluator TR::TreeEvaluator::pdstoreEvaluator
#define _udstStoreEvaluator TR::TreeEvaluator::pdstoreEvaluator
#define _udStoreiEvaluator TR::TreeEvaluator::pdstoreEvaluator
#define _udslStoreiEvaluator TR::TreeEvaluator::pdstoreEvaluator
#define _udstStoreiEvaluator TR::TreeEvaluator::pdstoreEvaluator
#define _pd2udEvaluator TR::TreeEvaluator::pd2udEvaluator
#define _pd2udslEvaluator TR::TreeEvaluator::pd2udslEvaluator
#define _pd2udstEvaluator TR::TreeEvaluator::pd2udslEvaluator
#define _udsl2udEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _udst2udEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ud2pdEvaluator TR::TreeEvaluator::ud2pdEvaluator
#define _udsl2pdEvaluator TR::TreeEvaluator::udsl2pdEvaluator
#define _udst2pdEvaluator TR::TreeEvaluator::udsl2pdEvaluator
#define _pdloadEvaluator TR::TreeEvaluator::pdloadEvaluator
#define _pdloadiEvaluator TR::TreeEvaluator::pdloadEvaluator
#define _pdstoreEvaluator TR::TreeEvaluator::pdstoreEvaluator
#define _pdstoreiEvaluator TR::TreeEvaluator::pdstoreEvaluator
#define _pdaddEvaluator TR::TreeEvaluator::pdaddEvaluator
#define _pdsubEvaluator TR::TreeEvaluator::pdsubEvaluator
#define _pdmulEvaluator TR::TreeEvaluator::pdmulEvaluator
#define _pddivEvaluator TR::TreeEvaluator::pddivremEvaluator
#define _pdremEvaluator TR::TreeEvaluator::pddivremEvaluator
#define _pdnegEvaluator TR::TreeEvaluator::pdnegEvaluator
#define _pdabsEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _pdshrEvaluator TR::TreeEvaluator::pdshrEvaluator
#define _pdshlEvaluator TR::TreeEvaluator::pdshlEvaluator
#define _pdshrSetSignEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _pdshlSetSignEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _pdshlOverflowEvaluator TR::TreeEvaluator::pdshlEvaluator
#define _pdchkEvaluator TR::TreeEvaluator::pdchkEvaluator
#define _pd2iEvaluator TR::TreeEvaluator::pd2iEvaluator
#define _pd2iOverflowEvaluator TR::TreeEvaluator::pd2iEvaluator
#define _pd2iuEvaluator TR::TreeEvaluator::pd2iEvaluator
#define _i2pdEvaluator TR::TreeEvaluator::i2pdEvaluator
#define _iu2pdEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _pd2lEvaluator TR::TreeEvaluator::pd2lEvaluator
#define _pd2lOverflowEvaluator TR::TreeEvaluator::pd2lEvaluator
#define _pd2luEvaluator TR::TreeEvaluator::pd2lEvaluator
#define _l2pdEvaluator TR::TreeEvaluator::l2pdEvaluator
#define _lu2pdEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _pd2fEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _pd2dEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _f2pdEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _d2pdEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _pdcmpeqEvaluator TR::TreeEvaluator::pdcmpeqEvaluator
#define _pdcmpneEvaluator TR::TreeEvaluator::pdcmpneEvaluator
#define _pdcmpltEvaluator TR::TreeEvaluator::pdcmpltEvaluator
#define _pdcmpgeEvaluator TR::TreeEvaluator::pdcmpgeEvaluator
#define _pdcmpgtEvaluator TR::TreeEvaluator::pdcmpgtEvaluator
#define _pdcmpleEvaluator TR::TreeEvaluator::pdcmpleEvaluator
#define _pdcleanEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _pdclearEvaluator TR::TreeEvaluator::pdclearEvaluator
#define _pdclearSetSignEvaluator TR::TreeEvaluator::pdclearEvaluator
#define _pdSetSignEvaluator TR::TreeEvaluator::pdSetSignEvaluator
#define _pdModifyPrecisionEvaluator TR::TreeEvaluator::pdModifyPrecisionEvaluator
#define _countDigitsEvaluator TR::TreeEvaluator::countDigitsEvaluator
#define _pd2dfEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _pd2dfAbsEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _df2pdEvaluator TR::TreeEvaluator::df2pdEvaluator
#define _df2pdSetSignEvaluator TR::TreeEvaluator::df2pdEvaluator
#define _df2pdCleanEvaluator TR::TreeEvaluator::df2pdEvaluator
#define _pd2ddEvaluator TR::TreeEvaluator::pd2ddEvaluator
#define _pd2ddAbsEvaluator TR::TreeEvaluator::pd2ddEvaluator
#define _dd2pdEvaluator TR::TreeEvaluator::df2pdEvaluator
#define _dd2pdSetSignEvaluator TR::TreeEvaluator::df2pdEvaluator
#define _dd2pdCleanEvaluator TR::TreeEvaluator::df2pdEvaluator
#define _pd2deEvaluator TR::TreeEvaluator::pd2ddEvaluator
#define _pd2deAbsEvaluator TR::TreeEvaluator::pd2ddEvaluator
#define _de2pdEvaluator TR::TreeEvaluator::df2pdEvaluator
#define _de2pdSetSignEvaluator TR::TreeEvaluator::df2pdEvaluator
#define _de2pdCleanEvaluator TR::TreeEvaluator::df2pdEvaluator
#define _BCDCHKEvaluator TR::TreeEvaluator::BCDCHKEvaluator

#include "z/codegen/OMRTreeEvaluatorTable.hpp"
